<template>
  <article class="view view--public-email-verification">
    <FancyAlert v-if="verified" type="success">
      Your email address has been verified. You should now be able to log in.
    </FancyAlert>
    <div v-else>
      <FancyAlert type="info">
        <p>You should have received an email with instructions on how to verify your email account.</p>
        <p>You can simply click the link in the email, or enter the validation code here.</p>
        <p>If you didn't receive the email, check your junk mail folder or click the link below to resend it.</p>
      </FancyAlert>
      <VForm
        name="account-email-verification-form"
        :fields="fields"
        :modelState="modelState"
        buttonText="Verify"
        buttonIconClass="bi bi-envelope-check"
        :busy="verifying"
        busyButtonText="Verifying..."
        @input="onInput"
        @submit="onSubmit"
        :error="errorDescription"
        :route="{ name: 'identity-public-resend-email-verification' }"
        routeText="Resend email verification"
      />
    </div>
  </article>
</template>

<script>
import { ref, computed, onMounted } from 'vue'
import { useRoute } from 'vue-router'
import { ValidationHelper, FancyAlert, VForm, useApi, useNotification } from '../../../core'
import UsersApi from '../../api/users-api'
import { useAuth } from '../../plugins/auth-plugin.js'

export default {
  name: 'IdentityPublicEmailVerificationView',
  components: {
    FancyAlert,
    VForm,
  },
  setup() {
    const route = useRoute()
    const api = useApi()
    const auth = useAuth()
    const notify = useNotification()
    const usersApi = new UsersApi(api, auth)

    const code = computed(() => {
      return ValidationHelper.getString(route.query.code, '')
    })

    const usernameOrEmail = computed(() => {
      return ValidationHelper.getString(route.query.usernameOrEmail, '')
    })

    const fields = ref([
      {
        type: 'text',
        name: 'usernameOrEmail',
        label: 'Username or email',
        validate: 'required',
        maxlength: 200,
        value: usernameOrEmail.value,
      },
      {
        type: 'text',
        name: 'code',
        label: 'Verification code',
        validate: 'required',
        maxlength: 200,
        value: code.value,
      },
    ])

    const modelState = ref({})
    const errorDescription = ref('')
    const verifying = ref(false)
    const verified = ref(false)

    const onInput = () => {
      errorDescription.value = ''
    }

    const onSubmit = async (form) => {
      await verifyAsync(form.usernameOrEmail, form.code)
    }

    const verifyAsync = async (usernameOrEmail, code) => {
      errorDescription.value = ''
      verifying.value = true
      verified.value = false

      try {
        await usersApi.verifyEmailAsync(usernameOrEmail, { verificationCode: code })
        verified.value = true
      } catch (ex) {
        if (ex.response.data?.modelState) {
          modelState.value = ex.response.data.modelState
        } else if (ex.response.data?.message) {
          errorDescription.value = ex.response.data.message
        } else {
          notify.error('There was a problem verifying your email.', ex)
        }
      } finally {
        verifying.value = false
      }
    }

    onMounted(async () => {
      if (usernameOrEmail.value && code.value) {
        await verifyAsync(usernameOrEmail.value, code.value)
      }
    })

    return {
      fields,
      modelState,
      errorDescription,
      verifying,
      verified,
      code,
      usernameOrEmail,
      onInput,
      onSubmit,
    }
  },
}
</script>
